/*
 * Copyright (C) 2020 Tianjin KYLIN Information Technology Co., Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 */
#ifndef UKWS_CLOSE_BUTTON_H
#define UKWS_CLOSE_BUTTON_H

#include <QLabel>
#include <QPainter>
#include <QMouseEvent>
#include <QDialog>
#include <QTimer>

//按钮几种按钮状态
enum BottonState{
    BTN_STATE_NORMAL,
    BTN_STATE_ENTER,
    BTN_STATE_PRESS,
    BTN_STATE_HOVER,
    BTN_STATE_NUM,
};

//定义按钮默认的的size
#define BTN_DEF_HEIGHT   24
#define BTN_DEF_WIDTH    24

class UkwsCloseButton: public QLabel
{
Q_OBJECT
public:
    explicit UkwsCloseButton(QWidget *parent = 0);
    void setBtnSize(int width, int heigh);
    void setBtnState(BottonState state);
    void startCircle();

signals:
    void buttonClicked();

protected:
    void paintEvent(QPaintEvent *event);

private slots:
    void onTimeout();

private:
    void btnStateNormal();
    void btnStateEnter();
    void btnStatePress();
    void btnStateHover();
    void btnStateUndef();

    QSize btnSize;
    QPixmap  default_closePix;
    QPixmap  hover_closePix;
    QPixmap  click_closePix;

    BottonState m_btnState = BTN_STATE_NORMAL;
    int m_nCirleCount = 0;
    int m_nAngle = 0;
    QTimer *m_pCircleTimer = Q_NULLPTR;
};

#endif // UKWS_CLOSE_BUTTON_H
